from flask import render_template, redirect, url_for, Blueprint

from database import app
from covid19.blueprints.app_application.application_model_transient import ApplicationPage


from covid19.blueprints.app_user.user_views import blueprint_app_user
from covid19.blueprints.app_admin.app_admin_views import blueprint_app_admin
from covid19.blueprints.app_all.all_views import blueprint_app_all

from covid19.blueprints.who.who_views import app_who
from covid19.blueprints.owid.owid_views import app_owid
from covid19.blueprints.ecdc.ecdc_views import app_ecdc
from covid19.blueprints.rki_vaccination.rki_vaccination_views import app_rki_vaccination
from covid19.blueprints.rki_cases.rki_views import app_rki
from covid19.blueprints.intensivregister.divi_views import app_divi

from covid19.blueprints.who_test.who_test_views import app_who_test
from covid19.blueprints.owid_test.owid_test_views import app_owid_test
from covid19.blueprints.ecdc_test.ecdc_test_views import app_ecdc_test
from covid19.blueprints.rki_cases_test.rki_test_views import app_rki_test
from covid19.blueprints.intensivregister_test.divi_test_views import app_divi_test

blueprint_application = Blueprint('application', __name__, template_folder='templates', url_prefix='/')

app.register_blueprint(blueprint_application, url_prefix='/')

app.register_blueprint(blueprint_app_user, url_prefix='/app/usr')
app.register_blueprint(blueprint_app_admin, url_prefix='/app/admin')
app.register_blueprint(blueprint_app_all, url_prefix='/app/all')

app.register_blueprint(app_who, url_prefix='/who')
app.register_blueprint(app_owid, url_prefix='/owid')
app.register_blueprint(app_ecdc, url_prefix='/ecdc')
app.register_blueprint(app_rki_vaccination, url_prefix='/rki/vaccination')
app.register_blueprint(app_rki, url_prefix='/rki/cases')
app.register_blueprint(app_divi, url_prefix='/divi')

app.register_blueprint(app_who_test, url_prefix='/who/test')
app.register_blueprint(app_owid_test, url_prefix='/owid/test')
app.register_blueprint(app_ecdc_test, url_prefix='/ecdc/test')
# app.register_blueprint(app_rki_vaccination_test, url_prefix='/rki/vaccination/test')
app.register_blueprint(app_rki_test, url_prefix='/rki/cases/test')
app.register_blueprint(app_divi_test, url_prefix='/divi/test')


############################################################################################
#
# WEB
#
@app.route('/home')
def url_home():
    page_info = ApplicationPage('Home', "Covid19 Data")
    return render_template(
        'app_application/page_home.html',
        page_info=page_info)


@app.route('/')
def url_root():
    return redirect(url_for('url_home'))
