import sys
from covid19 import app
from database import create_celery, db
from covid19.blueprints.app_all.all_services import app_user_service
from covid19.blueprints.app_application.application_service import ApplicationService


def start_redis(application_service):
    if sys.platform != 'linux':
        application_service.prepare_start_redis()
        redis_cmd = ['redis-server']
        # subprocess.Popen(redis_cmd, shell=True)


def run_mq(my_app, my_celery):
    application_service = ApplicationService(db, app_user_service)
    start_redis(application_service)
    application_service.prepare_run_mq()
    args = ['worker', '-l', 'INFO']
    my_celery.start(args)


celery = create_celery(app)
