from database import app
from covid19.blueprints.app_all.all_service_config import ApplicationServiceConfig
from covid19.blueprints.who.who_model import WhoDateReported, WhoData


class WhoTestService:
    def __init__(self, database, who_service):
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" WHO Test Service [init]")
        app.logger.debug("------------------------------------------------------------")
        self.__database = database
        self.__who_service = who_service
        self.cfg = ApplicationServiceConfig.create_config_for_who()
        app.logger.debug("------------------------------------------------------------")
        app.logger.info(" WHO Test Service [ready]")

    def delete_last_day(self):
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" WhoTestService.delete_last_day() [START]")
        app.logger.debug("------------------------------------------------------------")
        joungest_datum_str = WhoData.get_joungest_datum()
        joungest_datum = WhoDateReported.find_by_date_reported(joungest_datum_str)
        app.logger.info("joungest_datum:")
        app.logger.info(joungest_datum)
        app.logger.info("WhoData.get_data_for_one_day(joungest_datum):")
        i = 0
        for data in WhoData.get_data_for_one_day(joungest_datum):
            i += 1
            line = " | " + str(i) + " | " + str(data.date_reported) + " | " + data.country.country + " | to be deleted"
            app.logger.info(line)
        app.logger.info("WhoData.delete_data_for_one_day(joungest_datum)")
        WhoData.delete_data_for_one_day(joungest_datum)
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" WhoTestService.delete_last_day() [DONE]")
        app.logger.debug("------------------------------------------------------------")

    def run_update_star_schema_incremental(self):
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" WhoTestService.run_update_star_schema_incremental() [START]")
        app.logger.debug("------------------------------------------------------------")
        self.__who_service.run_update_star_schema_incremental()
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" WhoTestService.run_update_star_schema_incremental() [DONE]")
        app.logger.debug("------------------------------------------------------------")
